function smoothChannel(channelName, smoothedChannelName, windowLength, iterations) {
    let laps = telemetry.getAllLaps();
    for (let i = 0; i < laps.length; i++)
    {
        let lap = laps[i]
        let channel = lap.channel(channelName);

        if (!channel) {
            continue;
        }

        let smoothed = lap.editChannel(smoothedChannelName)
        for (let j = 0; j < channel.length; j++) {
          smoothed.setValue(j, channel.value(j));
        }

        for (let iter = 0; iter < iterations; iter++) {
            let smoothedValues = [];

            for (let j = 0; j < smoothed.length; j++) {
                let startIdx = Math.max(0, j - Math.floor(windowLength / 2));
                let endIdx = Math.min(smoothed.length - 1, j + Math.floor(windowLength / 2));
                let sum = 0;

                for (let k = startIdx; k <= endIdx; k++) {
                    sum += smoothed.value(k);
                }

                let average = sum / (endIdx - startIdx + 1);
                smoothedValues[j] = average;
            }
            
            for (let j = 0; j < smoothed.length; j++) {
                smoothed.setValue(j, smoothedValues[j]);
            }
        }
    }
}

let windowLength = 15;
let iterations = 1;
smoothChannel("lfrideheight", "lfrideheightsmooth", windowLength, iterations);
smoothChannel("rfrideheight", "rfrideheightsmooth", windowLength, iterations);
smoothChannel("lrrideheight", "lrrideheightsmooth", windowLength, iterations);
smoothChannel("rrrideheight", "rrrideheightsmooth", windowLength, iterations);
